package wenrgise.hrms.businessdelegate;

import java.rmi.RemoteException;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import javax.ejb.CreateException;
import wenrgise.common.bean.BaseHeaderBean;
import wenrgise.common.exception.EnrgiseApplicationException;
import wenrgise.common.exception.EnrgiseSystemException;
import wenrgise.common.utility.EnrgiseUtil;
import wenrgise.common.utility.RecordMetaInfo;
import wenrgise.common.vo.BaseQueryVO;
import wenrgise.common.vo.ThisPageVO;
import wenrgise.ejb.common.utility.ServiceLocator;
import wenrgise.hrms.bean.HrmChargeReportHdrBean;
import wenrgise.hrms.ejb.facade.HrmThirdFacade;
import wenrgise.hrms.ejb.facade.HrmThirdFacadeHome;
import wenrgise.hrms.vo.HrmATDTransChrgRptQVO;

public class HrmATDTransChrgRptBD extends HrmBaseBD {
  public RecordMetaInfo getHeaderMetaImpl(BaseQueryVO oQueryVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmThirdFacadeHome oHome = (HrmThirdFacadeHome)ServiceLocator.getLocator().getService("HrmThirdFacade");
      HrmThirdFacade oHrmThirdFacade = oHome.create();
      return oHrmThirdFacade.getHrmChargeRepHeaderMetaInfo((HrmATDTransChrgRptQVO)oQueryVO, this.oUserInfo);
    } catch (RemoteException oRe) {
      throw new EnrgiseSystemException(oRe);
    } catch (CreateException oCrt) {
      throw new EnrgiseSystemException(oCrt);
    } 
  }
  
  public ArrayList getHeaderRecordImpl(BaseQueryVO oQueryVO, long lStartPosition, long lLastPosition) throws RemoteException, EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmThirdFacadeHome oHome = (HrmThirdFacadeHome)ServiceLocator.getLocator().getService("HrmThirdFacade");
      HrmThirdFacade oHrmThirdFacade = oHome.create();
      ArrayList oHeaderList = oHrmThirdFacade.getHrmChargeRepHeader((HrmATDTransChrgRptQVO)oQueryVO, lStartPosition, lLastPosition, this.oUserInfo);
      return oHeaderList;
    } catch (RemoteException oRe) {
      throw new EnrgiseSystemException(oRe);
    } catch (CreateException oCrt) {
      throw new EnrgiseSystemException(oCrt);
    } 
  }
  
  public RecordMetaInfo getTotalDetailRecordCountImpl(String lPrimaryKey, String sScreenName) throws EnrgiseApplicationException, EnrgiseSystemException {
    RecordMetaInfo oRecordMetaInfo = null;
    return oRecordMetaInfo;
  }
  
  public ArrayList getDetailRecordImpl(String lPrimaryKey, String sScreenName, long lAbsoluteStart, long lAbsoluteEnd) throws RemoteException, EnrgiseApplicationException, EnrgiseSystemException {
    ArrayList oRet = null;
    return oRet;
  }
  
  public boolean updateHeaderRecordImpl(BaseHeaderBean oBaseHeaderBean) throws RemoteException, EnrgiseApplicationException, EnrgiseSystemException {
    return true;
  }
  
  public String getInsertDataImpl(BaseQueryVO oQueryVO) throws RemoteException, EnrgiseApplicationException, EnrgiseSystemException {
    return "Only Implementation";
  }
  
  public String saveImpl(BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked) throws RemoteException, EnrgiseApplicationException, EnrgiseSystemException {
    try {
      HrmThirdFacadeHome oHome = (HrmThirdFacadeHome)ServiceLocator.getLocator().getService("HrmThirdFacade");
      HrmThirdFacade oHrmThirdFacade = oHome.create();
      return oHrmThirdFacade.saveData((HrmChargeReportHdrBean)oBaseHeaderBean, oWhenPicked, sScreenName, sScreenMode, bHeaderDataChanged, oDetailBeanArray, bDetailDataChanged, oDetailPicked, this.oUserInfo);
    } catch (CreateException oCrtExcep) {
      throw new EnrgiseSystemException(oCrtExcep);
    } 
  }
  
  public String submitImpl(String sButtonName, BaseHeaderBean oBaseHeaderBean, Timestamp oWhenPicked, String sScreenName, String sScreenMode, boolean bHeaderDataChanged, ArrayList oDetailBeanArray, boolean bDetailDataChanged, Timestamp oDetailPicked) throws RemoteException, EnrgiseApplicationException, EnrgiseSystemException {
    return new String();
  }
  
  public Map getDisabledFieldsImpl(ThisPageVO oThisPageVO) throws EnrgiseApplicationException, EnrgiseSystemException {
    HashMap oHashMap = new HashMap();
    ArrayList arylstEnableList = new ArrayList();
    ArrayList arylstDisableList = new ArrayList();
    HrmChargeReportHdrBean oHrmChargeReportHdrBean = (HrmChargeReportHdrBean)oThisPageVO.getOHeaderBean();
    ArrayList oDetailList = oThisPageVO.getODetailList();
    if (oThisPageVO.getScreenMode().equalsIgnoreCase("Q")) {
      if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getChargeType())) {
        arylstEnableList.add("butTrnOrderNo");
      } else {
        arylstDisableList.add("butTrnOrderNo");
      } 
      arylstDisableList.add("butEmployee");
      if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getTrnOrderNoId())) {
        arylstEnableList.add("butExecute");
      } else {
        arylstDisableList.add("butExecute");
      } 
    } 
    if (!oHrmChargeReportHdrBean.equals(null))
      if (oThisPageVO.getScreenMode().equalsIgnoreCase("N")) {
        if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getChargeType())) {
          arylstEnableList.add("butTrnOrderNo");
        } else {
          arylstDisableList.add("butTrnOrderNo");
        } 
        arylstEnableList.add("butEmployee");
        if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getChargeType()))
          arylstDisableList.add("butChargeCode"); 
      } else if (oThisPageVO.getScreenMode().equalsIgnoreCase("Q")) {
        if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getChargeType())) {
          arylstEnableList.add("butTrnOrderNo");
        } else {
          arylstDisableList.add("butTrnOrderNo");
        } 
        arylstDisableList.add("butEmployee");
        if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getChargeType())) {
          arylstEnableList.add("butChargeCode");
        } else {
          arylstDisableList.add("butChargeCode");
        } 
      } else if (EnrgiseUtil.checkString(oHrmChargeReportHdrBean.getChargeStatus())) {
        if (oHrmChargeReportHdrBean.getChargeStatus().equalsIgnoreCase("P") || oHrmChargeReportHdrBean.getChargeStatus().equalsIgnoreCase("A") || oHrmChargeReportHdrBean.getChargeStatus().equalsIgnoreCase("R")) {
          arylstDisableList.add("trnOrderNo");
          arylstDisableList.add("butTrnOrderNo");
          arylstDisableList.add("chargeCode");
          arylstDisableList.add("butChargeCode");
          arylstDisableList.add("chargeType");
          arylstDisableList.add("butHandOverDate");
          arylstDisableList.add("noonFlag");
          arylstDisableList.add("remarks");
          arylstDisableList.add("butEmployee");
        } else {
          arylstDisableList.add("butChargeCode");
        } 
      }  
    oThisPageVO.setOHeaderBean((BaseHeaderBean)oHrmChargeReportHdrBean);
    oHashMap.put("D", arylstDisableList);
    oHashMap.put("E", arylstEnableList);
    return oHashMap;
  }
  
  public void onLoadAction(ThisPageVO oThisPageVO) throws EnrgiseApplicationException, EnrgiseSystemException {}
}
